VERSION 5.00
Begin VB.UserControl OCXDialogs 
   ClientHeight    =   525
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   555
   InvisibleAtRuntime=   -1  'True
   Picture         =   "OCXDialogs.ctx":0000
   ScaleHeight     =   35
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   37
   ToolboxBitmap   =   "OCXDialogs.ctx":0B82
End
Attribute VB_Name = "OCXDialogs"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
            '---------------------------------------[-][x]--'
            '-----------------[ OCXDialogs ]----------------'
            '-----------------------------------------------'
            '  _________________________                    '
            '  Ime: OCXDialogs                              '
            '  Tip: OCX Control                             '
            '  Autor: Aleksandar Ruzicic - krckoorascic     '
            '  Kontakt: tesla.scg@gmail.com                 '
            '  Zavrseno: Nedelja, Novembar 14, 2004. 00:05  '
            '                                               '
            '-----------------------------------------------'
            
'----[ API's ]----'
Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long
Private Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long
Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)

'----[ Types ]----'
Private Type BrowseInfo
    hwndOwner         As Long
    pIDLRoot          As Long
    pszDisplayName    As Long
    lpszTitle         As Long
    ulFlags           As Long
    lpfnCallback      As Long
    lParam            As Long
    iImage            As Long
End Type

Private Type OPENFILENAME
    lStructSize       As Long
    hwndOwner         As Long
    hInstance         As Long
    lpstrFilter       As String
    lpstrCustomFilter As String
    nMaxCustFilter    As Long
    nFilterIndex      As Long
    lpstrFile         As String
    nMaxFile          As Long
    lpstrFileTitle    As String
    nMaxFileTitle     As Long
    lpstrInitialDir   As String
    lpstrTitle        As String
    flags             As Long
    nFileOffset       As Integer
    nFileExtension    As Integer
    lpstrDefExt       As String
    lCustData         As Long
    lpfnHook          As Long
    lpTemplateName    As String
End Type

Private Type SHITEMID
    cb                As Long
    abID              As Byte
End Type

Private Type ITEMIDLIST
    mkid              As SHITEMID
End Type

'----[ Enums ]----'
Public Enum SpecialFolderConstants
    sfcDesktop = &H0
    sfcPrograms = &H2
    sfcDocuments = &H5
    sfcFavorites = &H6
    sfcStartUp = &H7
    sfcRecent = &H8
    sfcSendTo = &H9
    sfcStartMenu = &HB
    sfcDesktopDirectory = &H10
    sfcNetHood = &H13
    sfcFonts = &H14
    sfcShellNew = &H15
    sfcWindows = &H16
    sfcTemporary = &H17
    sfcSystem = &H18
    sfcProgramFiles = &H26
End Enum

'----[ Constants 0----'
Private Const BIF_RETURNONLYFSDIRS = 1
Private Const MAX_PATH = 260

'----[ Dim's ]----'
Private m_title       As String
Private m_filter      As String
Private m_defaultext  As String
Private m_initdir     As String
Private m_filename    As String
Private m_filetitle   As String
Private m_fileext     As String
Private m_folder      As String
Private m_caption     As String
Private OFName        As OPENFILENAME

'----[ Properties ]----'
Public Property Let DialogTitle(ByVal newtitle As String)
    m_title = newtitle
End Property
Public Property Get DialogTitle() As String
    DialogTitle = m_title
End Property
Public Property Let Filter(ByVal newfilter As String)
    m_filter = Replace(newfilter, "|", vbNullChar)
End Property
Public Property Get Filter() As String
    Filter = Replace(m_filter, vbNullChar, "|")
End Property
Public Property Let DefaultExt(ByVal newext As String)
    m_defaultext = newext
End Property
Public Property Get DefaultExt() As String
    DefaultExt = m_defaultext
End Property
Public Property Let InitDir(ByVal init As String)
    m_initdir = init
End Property
Public Property Get InitDir() As String
    InitDir = m_initdir
End Property
Public Property Get Filename() As String
    Filename = m_filename
End Property
Public Property Get FileTitle() As String
    FileTitle = m_filetitle
End Property
Public Property Get FileExt() As String
    FileExt = m_fileext
End Property
Public Property Get SelectdFolder() As String
    selectedfolder = m_folder
End Property
Public Property Let DialogCaption(ByVal newcaption As String)
    m_caption = newcaption
End Property
Public Property Get DialogCaption() As String
    DialogCaption = m_caption
End Property

'----[ Methods ]----'
Public Sub OpenFile()
    OFName.lStructSize = Len(OFName)
    OFName.hwndOwner = UserControl.ContainerHwnd
    OFName.hInstance = App.hInstance
    OFName.lpstrFilter = m_filter
    OFName.lpstrDefExt = m_defaultext
    OFName.lpstrFile = Space$(254)
    OFName.nMaxFile = 255
    OFName.lpstrFileTitle = Space$(254)
    OFName.nMaxFileTitle = 255
    OFName.lpstrInitialDir = m_initdir
    OFName.lpstrTitle = m_title
    OFName.flags = 0
    
    If (GetOpenFileName(OFName)) Then
        m_filename = Trim$(OFName.lpstrFile)
        m_fileext = Mid$(m_filename, InStrRev(m_filename, ".") + 1)
        m_filetitle = OFName.lpstrFileTitle
    Else 'cancel
        m_filename = ""
        m_fileext = ""
        m_filetitle = ""
    End If
End Sub
Public Sub SaveFile()
    OFName.lStructSize = Len(OFName)
    OFName.hwndOwner = UserControl.ContainerHwnd
    OFName.hInstance = App.hInstance
    OFName.lpstrFilter = m_filter
    OFName.lpstrDefExt = m_defaultext
    OFName.lpstrFile = Space$(254)
    OFName.nMaxFile = 255
    OFName.lpstrFileTitle = Space$(254)
    OFName.nMaxFileTitle = 255
    OFName.lpstrInitialDir = m_initdir
    OFName.lpstrTitle = m_title
    OFName.flags = 0

    If GetSaveFileName(OFName) Then
        m_filename = Trim$(OFName.lpstrFile)
        m_fileext = Mid$(m_filename, InStrRev(m_filename, ".") + 1)
        m_filetitle = OFName.lpstrFileTitle
    Else 'cancel
        m_filename = ""
        m_fileext = ""
        m_filetitle = ""
    End If
End Sub
Public Sub PickFolder()
    Dim iNull       As Integer
    Dim lpIDList    As Long
    Dim lResult     As Long
    Dim sPath       As String
    Dim udtBI       As BrowseInfo
    
    With udtBI
        .hwndOwner = UserControl.ContainerHwnd
        .lpszTitle = lstrcat(m_caption, "")
        .ulFlags = BIF_RETURNONLYFSDIRS
    End With

    lpIDList = SHBrowseForFolder(udtBI)
    If lpIDList Then
        sPath = String$(MAX_PATH, 0)
        SHGetPathFromIDList lpIDList, sPath
        CoTaskMemFree lpIDList
        iNull = InStr(sPath, vbNullChar)
        If iNull Then
            sPath = Left$(sPath, iNull - 1)
        End If
    End If
    m_folder = sPath
End Sub
Public Function GetSpecialFolder(ByVal Folder As SpecialFolderConstants) As String
    Dim r    As Long
    Dim IDL  As ITEMIDLIST
    Dim Ret  As String
    
    If (Folder = sfcSystem) Then
        Ret = Space(255)
        r = GetSystemDirectory(Ret, 255)
        Ret = Left$(Ret, r)
    ElseIf (Folder = sfcTemporary) Then
        Ret = String(100, Chr$(0))
        GetTempPath 100, Ret
        Ret = Left$(Ret, InStr(Ret, Chr$(0)) - 1)
    ElseIf (Folder = sfcWindows) Then
        Ret = String(200, Chr$(0))
        r = GetWindowsDirectory(Ret, Len(Ret))
        Ret = Left$(Ret, r)
    Else
        r = SHGetSpecialFolderLocation(100, Folder, IDL)
        If r = NOERROR Then
            Path$ = Space$(512)
            r = SHGetPathFromIDList(ByVal IDL.mkid.cb, ByVal Path$)
            Ret = Left$(Path, InStr(Path, Chr$(0)) - 1)
        Else
            Ret = ""
        End If
    End If
    GetSpecialFolder = Ret
End Function
Private Sub UserControl_Resize()
    UserControl.Width = 32 * Screen.TwipsPerPixelX
    UserControl.Height = 30 * Screen.TwipsPerPixelY
End Sub
